/* Problem URL: https://codeforces.com/contest/2116/problem/B */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;


void pre()
{

}

#define TEST 1

void solve()
{
    int n;
    cin >> n;

    vi apos(n);
    vi bpos(n);

    vi a(n);
    vi b(n);

    rep(i, n) {
        int p;
        cin >> p;
        apos[p] = i;
        a[i] = p;
    }

    rep(i, n) {
        int p;
        cin >> p;
        bpos[p] = i;
        b[i] = p;
    }

    V<pair<int, int>> ans(n);

    set<int> pos;
    rep(i, n) {
        pos.insert(i);
    }

    for (int i = n - 1; i >= 0; i--) {
        set<int> rem;

        auto getans = [&](int now, int p, vi &other) {
            auto itr = pos.lower_bound(p);

            while (itr != pos.end()) {
                pair<int, int> act = {now, other[*itr - p]};
                rmax(ans[*itr], act);
                rem.insert(*itr);
                itr++;
            }
        };

        getans(a[apos[i]], apos[i], b);
        getans(b[bpos[i]], bpos[i], a);

        repv(i, rem) {
            pos.erase(i);
        }
    }

    const ll mod = 998244353;
    auto fpow = [&](ll a, ll p) {
        ll ans = 1;

        rep(i, 30) {
            if ((p >> i) & 1) {
                ans = (ans * a) % mod;
            }
            a = (a * a) % mod;
        }

        return ans;
    };

    rep(i, n) {
        cout << (fpow(2, ans[i].first) + fpow(2, ans[i].second)) % mod << " \n"[i == n - 1];
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
